#ifndef _LKL_LINUX_VIRTIO_IDS_H
#define _LKL_LINUX_VIRTIO_IDS_H
/*
 * Virtio IDs
 *
 * This header is BSD licensed so anyone can use the definitions to implement
 * compatible drivers/servers.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of IBM nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL IBM OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE. */

#define LKL_VIRTIO_ID_NET			1 /* virtio net */
#define LKL_VIRTIO_ID_BLOCK			2 /* virtio block */
#define LKL_VIRTIO_ID_CONSOLE		3 /* virtio console */
#define LKL_VIRTIO_ID_RNG			4 /* virtio rng */
#define LKL_VIRTIO_ID_BALLOON		5 /* virtio balloon */
#define LKL_VIRTIO_ID_IOMEM			6 /* virtio ioMemory */
#define LKL_VIRTIO_ID_RPMSG			7 /* virtio remote processor messaging */
#define LKL_VIRTIO_ID_SCSI			8 /* virtio scsi */
#define LKL_VIRTIO_ID_9P			9 /* 9p virtio console */
#define LKL_VIRTIO_ID_MAC80211_WLAN		10 /* virtio WLAN MAC */
#define LKL_VIRTIO_ID_RPROC_SERIAL		11 /* virtio remoteproc serial link */
#define LKL_VIRTIO_ID_CAIF			12 /* Virtio caif */
#define LKL_VIRTIO_ID_MEMORY_BALLOON	13 /* virtio memory balloon */
#define LKL_VIRTIO_ID_GPU			16 /* virtio GPU */
#define LKL_VIRTIO_ID_CLOCK			17 /* virtio clock/timer */
#define LKL_VIRTIO_ID_INPUT			18 /* virtio input */
#define LKL_VIRTIO_ID_VSOCK			19 /* virtio vsock transport */
#define LKL_VIRTIO_ID_CRYPTO		20 /* virtio crypto */
#define LKL_VIRTIO_ID_SIGNAL_DIST		21 /* virtio signal distribution device */
#define LKL_VIRTIO_ID_PSTORE		22 /* virtio pstore device */
#define LKL_VIRTIO_ID_IOMMU			23 /* virtio IOMMU */
#define LKL_VIRTIO_ID_MEM			24 /* virtio mem */
#define LKL_VIRTIO_ID_SOUND			25 /* virtio sound */
#define LKL_VIRTIO_ID_FS			26 /* virtio filesystem */
#define LKL_VIRTIO_ID_PMEM			27 /* virtio pmem */
#define LKL_VIRTIO_ID_RPMB			28 /* virtio rpmb */
#define LKL_VIRTIO_ID_MAC80211_HWSIM	29 /* virtio mac80211-hwsim */
#define LKL_VIRTIO_ID_VIDEO_ENCODER		30 /* virtio video encoder */
#define LKL_VIRTIO_ID_VIDEO_DECODER		31 /* virtio video decoder */
#define LKL_VIRTIO_ID_SCMI			32 /* virtio SCMI */
#define LKL_VIRTIO_ID_NITRO_SEC_MOD		33 /* virtio nitro secure module*/
#define LKL_VIRTIO_ID_I2C_ADAPTER		34 /* virtio i2c adapter */
#define LKL_VIRTIO_ID_WATCHDOG		35 /* virtio watchdog */
#define LKL_VIRTIO_ID_CAN			36 /* virtio can */
#define LKL_VIRTIO_ID_DMABUF		37 /* virtio dmabuf */
#define LKL_VIRTIO_ID_PARAM_SERV		38 /* virtio parameter server */
#define LKL_VIRTIO_ID_AUDIO_POLICY		39 /* virtio audio policy */
#define LKL_VIRTIO_ID_BT			40 /* virtio bluetooth */
#define LKL_VIRTIO_ID_GPIO			41 /* virtio gpio */

/*
 * Virtio Transitional IDs
 */

#define LKL_VIRTIO_TRANS_ID_NET		0x1000 /* transitional virtio net */
#define LKL_VIRTIO_TRANS_ID_BLOCK		0x1001 /* transitional virtio block */
#define LKL_VIRTIO_TRANS_ID_BALLOON		0x1002 /* transitional virtio balloon */
#define LKL_VIRTIO_TRANS_ID_CONSOLE		0x1003 /* transitional virtio console */
#define LKL_VIRTIO_TRANS_ID_SCSI		0x1004 /* transitional virtio SCSI */
#define LKL_VIRTIO_TRANS_ID_RNG		0x1005 /* transitional virtio rng */
#define LKL_VIRTIO_TRANS_ID_9P		0x1009 /* transitional virtio 9p console */

#endif /* _LKL_LINUX_VIRTIO_IDS_H */
